diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/vncviewer.c vnc_unixsrc/vncviewer/vncviewer.c
--- vnc_unixsrc.orig/vncviewer/vncviewer.c	2004-01-13 09:22:05.000000000 -0500
+++ vnc_unixsrc/vncviewer/vncviewer.c	2010-04-18 12:43:47.000000000 -0400
@@ -22,6 +22,8 @@
  */
 
 #include "vncviewer.h"
+#include <ctype.h>
+#include <X11/Xaw/Toggle.h>
 
 char *programName;
 XtAppContext appContext;
@@ -29,11 +31,274 @@
 
 Widget toplevel;
 
+extern void raiseme(int force);
+extern void CreateChat(void);
+
+void set_sbwidth(int sbw) {
+	char *q, *p, t[5];
+	int i, k, N = 4;
+	int db = 0;
+
+	if (sbw < 1) {
+		sbw = 2;
+	} else if (sbw > 100) {
+		sbw = 100;
+	}
+	if (db) fprintf(stderr, "sbw: %d\n", sbw);
+
+	sprintf(t, "%4d", sbw);
+	k = 0;
+	while (fallback_resources[k] != NULL) {
+		q = strstr(fallback_resources[k], "horizontal.height: ");
+		if (!q) {
+			q = strstr(fallback_resources[k], "vertical.width: ");
+		}
+		if (q) {
+			p = strdup(fallback_resources[k]);
+			q = strstr(p, ":   ");
+			if (q) {
+				q++;
+				q++;
+				for (i=0; i < N; i++) {
+					*(q+i) = t[i];
+				}
+				fallback_resources[k] = p;
+				if (db) fprintf(stderr, "res: %s\n\n", p);
+			}
+		}
+		k++;
+	}
+}
+
+void min_title(void) {
+	char *q;
+	int k;
+
+	k = 0;
+	while (fallback_resources[k] != NULL) {
+		q = strstr(fallback_resources[k], "Ssvnc.title: ");
+		if (q) {
+			fallback_resources[k] = strdup("Ssvnc.title: %s");
+		}
+		k++;
+	}
+}
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+
+void unixpw(char *instr, int vencrypt_plain) {
+	char *str, *q, *infile = NULL;
+	FILE *in;
+	int i, rmfile = 0;
+	struct stat sb;
+	int N = 99;
+	char username[100], passwd[100];
+	static int did = 0;
+
+	if (did) {
+		return;
+	}
+	did = 1;
+
+	for (i=0; i<100; i++) {
+		username[i] = '\0';
+		passwd[i] = '\0';
+	}
+
+	if (instr == NULL) {
+		return;
+	} else if (!strcmp(instr, "")) {
+		return;
+	}
+
+	str = strdup(instr);
+	
+	if (strstr(str, "rm:") == str) {
+		rmfile = 1;
+		infile = str + strlen("rm:");
+	} else if (stat(str, &sb) == 0) {
+		infile = str;
+	}
+	if (!strcmp(str, ".")) {
+		char *p;
+		if (!use_tty()) {
+			char *u;
+			fprintf(stderr, "\nEnter Unix Username and Password in the popups.\n");
+			u = DoUserDialog();
+			if (strlen(u) >= 100) {
+				exit(1);
+			}
+			sprintf(username, u);
+			p = DoPasswordDialog();
+		} else {
+			raiseme(1);
+			fprintf(stderr, "\nUnix Username: ");
+			if (fgets(username, N, stdin) == NULL) {
+				exit(1);
+			}
+			p = getpass("Unix Password: ");
+		}
+		if (! p) {
+			exit(1);
+		}
+		strncpy(passwd, p, N);
+		fprintf(stderr, "\n");
+		
+	} else if (!strcmp(str, "-")) {
+		char *p, *q;
+		if (!use_tty()) {
+			fprintf(stderr, "\nEnter unixuser@unixpasswd in the popup.\n");
+			p = DoPasswordDialog();
+		} else {
+			raiseme(1);
+			p = getpass("unixuser@unixpasswd: ");
+		}
+		if (! p) {
+			exit(1);
+		}
+		q = strchr(p, '@');
+		if (! q) {
+			exit(1);
+		}
+		*q = '\0';
+		strncpy(username, p, N);
+		strncpy(passwd, q+1, N);
+		
+	} else if (infile) {
+		in = fopen(infile, "r");	
+		if (in == NULL) {
+			fprintf(stderr, "failed to open -unixpw file.\n");
+			exit(1);
+		}
+		if (fgets(username, N, in) == NULL) {
+			exit(1);
+		}
+		if (fgets(passwd, N, in) == NULL) {
+			exit(1);
+		}
+		fclose(in);
+		fprintf(stderr, "read username@passwd from file: %s\n", infile);
+		if (rmfile) {
+			fprintf(stderr, "deleting username@passwd file:  %s\n", infile);
+			unlink(infile);
+		}
+	} else if (strchr(str, '@'))  {
+		char *q = strchr(str, '@');
+		*q = '\0';
+		strncpy(username, str, N);
+		strncpy(passwd, q+1, N);
+	} else {
+		exit(1);
+	}
+
+	free(str);
+	
+	if (vencrypt_plain) {
+		CARD32 ulen, plen;
+		char *q;
+
+		q = strrchr(username, '\n');
+		if (q) *q = '\0';
+		q = strrchr(passwd, '\n');
+		if (q) *q = '\0';
+
+		ulen = Swap32IfLE((CARD32)strlen(username));
+		plen = Swap32IfLE((CARD32)strlen(passwd));
+
+		if (!WriteExact(rfbsock, (char *)&ulen, 4) ||
+		    !WriteExact(rfbsock, (char *)&plen, 4)) {
+			return;
+		}
+
+		if (!WriteExact(rfbsock, username, strlen(username)) ||
+		    !WriteExact(rfbsock, passwd, strlen(passwd))) {
+			return;
+		}
+		return;
+	}
+
+
+	if (! getenv("SSVNC_UNIXPW_NOESC")) {
+		SendKeyEvent(XK_Escape, 1);
+		SendKeyEvent(XK_Escape, 0);
+	}
+
+	q = username;
+	while (*q != '\0' && *q != '\n') {
+		char c = *q;
+		if (c >= 0x20 && c <= 0x07e) {
+			KeySym ks = (KeySym) c;
+			SendKeyEvent(ks, 1);
+			SendKeyEvent(ks, 0);
+		}
+		q++;
+	}
+
+	SendKeyEvent(XK_Return, 1);
+	SendKeyEvent(XK_Return, 0);
+	
+	q = passwd;
+	while (*q != '\0' && *q != '\n') {
+		char c = *q;
+		if (c >= 0x20 && c <= 0x07e) {
+			KeySym ks = (KeySym) c;
+			SendKeyEvent(ks, 1);
+			SendKeyEvent(ks, 0);
+		}
+		q++;
+	}
+
+	SendKeyEvent(XK_Return, 1);
+	SendKeyEvent(XK_Return, 0);
+}
+
+static void chat_window_only(void) {
+	if (appData.chatOnly) {
+		static double last_time = 0.0;
+		if (dnow() > last_time + 1.5) {
+			XSync(dpy, False);
+			XUnmapWindow(dpy, XtWindow(toplevel));
+		}
+	}
+}
+
+int saw_appshare = 0;
+
 int
 main(int argc, char **argv)
 {
-  int i;
-  programName = argv[0];
+	int i, save_sbw, saw_listen = 0;
+	char *pw_loc = NULL;
+	programName = argv[0];
+
+	if (strrchr(programName, '/') != NULL) {
+		programName = strrchr(programName, '/') + 1;
+	}
+
+	for (i = 1; i < argc; i++) {
+		if (!strcmp(argv[i], "-env")) {
+			if (i+1 < argc) {
+				char *estr = argv[i+1];
+				if (strchr(estr, '=')) {
+					putenv(estr);
+				}
+			}
+		}
+		if (!strcmp(argv[i], "-noipv4")) {
+			putenv("VNCVIEWER_NO_IPV4=1");
+		}
+		if (!strcmp(argv[i], "-noipv6")) {
+			putenv("VNCVIEWER_NO_IPV6=1");
+		}
+	}
+	if (getenv("VNCVIEWER_NO_IPV4")) {
+		appData.noipv4 = True;
+	}
+	if (getenv("VNCVIEWER_NO_IPV6")) {
+		appData.noipv6 = True;
+	}
 
   /* The -listen option is used to make us a daemon process which listens for
      incoming connections from servers, rather than actively connecting to a
